# Changelog

## 2025-04-30 - 6.0.1 - fix(smartexpect)
Update @push.rocks/smartexpect dependency version to ^2.3.2 in package.json

- Bump @push.rocks/smartexpect from ^2.2.0 to ^2.3.2

## 2025-04-29 - 6.0.0 - BREAKING CHANGE(dependencies)
Upgrade @push.rocks/smartexpect to ^2.2.0 and bump @types/node version; remove unused expectAsync import from ts/index.ts

- Updated '@push.rocks/smartexpect' from ^1.6.1 to ^2.2.0, which may introduce breaking API changes for consumers
- Bumped '@types/node' from ^22.14.0 to ^22.15.3
- Removed redundant expectAsync import from ts/index.ts

## 2025-04-08 - 5.6.3 - fix(package.json)
Update dependency versions for smartmongo, smartrequest, tsbuild, and @types/node

- Bump @push.rocks/smartmongo from 2.0.10 to 2.0.12
- Bump @push.rocks/smartrequest from 2.0.23 to 2.1.0
- Bump @git.zone/tsbuild from 2.2.6 to 2.3.2
- Bump @types/node from 22.13.10 to 22.14.0

## 2025-04-02 - 5.6.2 - fix(package.json)
Fix formatting in package.json to correctly include the packageManager field

- Added missing comma after the keywords array
- Ensured proper inclusion of the packageManager field for consistency

## 2025-04-02 - 5.6.1 - fix(readme)
Update README: Revamp structure for features, installation, and examples

- Reorganized sections to highlight features, installation, core API, and getting started
- Updated code examples for clarity, including Node integration and web testing sections
- Standardized headings and removed extraneous documentation details

## 2025-03-17 - 5.6.0 - feat(tap)
Add explicit fail method to the Tap class for better test failure handling

- Introduced fail() method that throws a custom error message to explicitly mark test failures
- Improves clarity in test flow by giving developers a direct way to trigger error states

## 2025-03-08 - 5.5.10 - fix(node)
Removed unused jest dependency from project.

- Removed '@jest/globals' from dependencies in package.json.
- Removed unused jest import from ts_node/index.ts.
- Kept 'expect' dependency from jest library.

## 2025-03-08 - 5.5.9 - fix(dependencies)
Fix missing jest dependency in package.json and update exports in ts_node/index.ts

- Added missing '@jest/globals' dependency to package.json.
- Updated ts_node/index.ts to properly export jest along with jestExpect.

## 2025-03-08 - 5.5.8 - fix(test)
Ensure compatibility with async/await in test cases.


## 2025-03-08 - 5.5.7 - fix(dependencies)
Updated project dependencies to the latest versions for improved stability and performance.

- Updated `@push.rocks/smartexpect` to version 1.6.1.
- Updated `@push.rocks/smartfile` to version 11.2.0.
- Updated `@push.rocks/smartpromise` to version 4.2.3.
- Updated `@push.rocks/smartshell` to version 3.2.3.
- Updated `@git.zone/tsbuild` to version 2.2.6.
- Updated `@git.zone/tstest` to version 1.0.96.
- Updated `@types/node` to version 22.13.10.

## 2025-01-19 - 5.5.6 - fix(dependencies)
Update smartpromise dependency to version 4.2.0.

- Updated @push.rocks/smartpromise dependency from version 4.1.0 to 4.2.0 in package.json.

## 2025-01-19 - 5.5.5 - fix(dependencies)
Update dependencies to the latest versions to address multiple fixes.

- Updated @push.rocks/smartexpect to version ^1.4.0.
- Updated @push.rocks/smartfile to version ^11.1.5.
- Updated @push.rocks/smartpromise to version ^4.1.0.
- Updated @types/node to version ^22.10.7.
- Updated randomstring to version ^1.3.1.

## 2024-12-30 - 5.5.4 - fix(dependencies)
Update package dependencies to their latest versions.

- Updated @push.rocks/smartexpect from ^1.2.1 to ^1.3.0.
- Updated @push.rocks/smartfile from ^11.0.21 to ^11.0.23.
- Updated @push.rocks/smartshell from ^3.0.6 to ^3.2.2.
- Updated @push.rocks/smarttime from ^4.0.8 to ^4.1.1.
- Updated @types/node from ^22.9.3 to ^22.10.2.

## 2024-11-23 - 5.5.3 - fix(docs)
Update description and keywords in package files for clarity

- Updated project description in package.json and npmextra.json for better clarity.
- Enhanced keywords list in package.json and npmextra.json to cover more relevant topics.
- Revised README.md content to provide a more comprehensive usage guide and correct mismatched sections.

## 2024-11-23 - 5.5.2 - fix(core)
Apply code cleanup and refactoring.


## 2024-11-23 - 5.5.1 - fix(core)
Update dependencies and add jestExpect export

- Updated '@push.rocks/qenv' to '^6.1.0' in dependencies.
- Updated 'expect' package version to '^29.7.0' in dependencies.
- Updated '@types/node' to '^22.9.3' in devDependencies.
- Added jestExpect export in ts_node/index.ts.

## 2024-11-06 - 5.5.0 - feat(tapnodetools)
Add TestFileProvider for handling Docker Alpine image

- Introduced TestFileProvider in TapNodeTools.
- Added method to retrieve Docker Alpine image as a local tarball.

## 2024-11-06 - 5.4.4 - fix(dependencies)
Update smarts3 dependency to version 2.2.5


## 2024-11-06 - 5.4.3 - fix(TapNodeTools)
Fix server port default value in createSmarts3 method

- The `createSmarts3` method in `TapNodeTools` now explicitly sets the port to 3003.

## 2024-11-06 - 5.4.2 - fix(dependencies)
Update smarts3 dependency version to fix issues.

- Changed the version of @push.rocks/smarts3 from ^2.2.1 to ^2.2.2.

## 2024-11-06 - 5.4.1 - fix(ci)
Fix CI configuration URL and package installation paths.

- Updated Docker image URL in CI config.
- Fixed repository URL format in package.json.
- Corrected npmci package installation path.

## 2024-11-06 - 5.4.0 - feat(node)
Add smartmongo and smarts3 integration in node tools

- Added createSmartmongo method to TapNodeTools for creating SmartMongo instances.
- Added createSmarts3 method to TapNodeTools for creating Smarts3 instances.
- Updated dependencies with smartmongo and smarts3 in package.json.

## 2024-09-19 - 5.3.0 - feat(TapNodeTools)
Add getEnvVarOnDemand method to TapNodeTools

- Introduced a new method getEnvVarOnDemand to the TapNodeTools class to fetch environment variables on demand.
- Enhanced getQenv function in TapNodeTools class to cache the Qenv instance for better performance.

## 2024-09-19 - 5.2.2 - fix(core)
Ensure reliability in test setup and execution

- Added new pre-task functionality to log starting of tasks.
- Enhanced `runCommand` method to better handle shell command execution.
- Fixed issue in `createHttpsCert` to correctly generate self-signed certificates.

## 2024-09-19 - 5.2.1 - fix(tapbundle)
Add qenv package to dependencies for environment management

- Added @push.rocks/qenv to dependencies in package.json.
- Updated TapNodeTools class in ts_node/classes.tapnodetools.ts to include getQenv method.
- Imported qenv in ts_node/plugins.ts.

## 2024-09-18 - 5.2.0 - feat(TapNodeTools)
Add ability to create HTTPS certificates with self-signed option

- Introduced a new parameter `allowSelfSigned` to the `createHttpsCert` function.

## 2024-09-18 - 5.1.4 - fix(ts_node)
Fixed issues in HTTPS certificate generation for TapNodeTools

- Updated 'createHttpsCert' method in 'TapNodeTools' to use 'smartcrypto' for generating RSA key pair and self-signed certificate.
- Corrected certificate and private key PEM encoding.

## 2024-09-18 - 5.1.3 - fix(ts_node/classes.tapnodetools.ts)
Refactored methods and improved type annotations in TapNodeTools class.

- Refactored `runCommand` method to include proper type annotations.
- Enhanced `createHttpsCert` method with proper type annotations and key generation logic.
- Introduced `generateSelfSignedCert` method for better code organization and readability.

## 2024-09-18 - 5.1.2 - fix(TapNodeTools)
Default parameter added to createHttpsCert method

- Updated createHttpsCert method to provide a default value for the parameter commonName.

## 2024-09-18 - 5.1.1 - fix(ts_node)
Fixed createHttpsCert interface

- Removed unnecessary keyFile and certFile parameters from createHttpsCert method.

## 2024-09-18 - 5.1.0 - feat(ts_node)
Add support for HTTPS certificate creation

- Added TapNodeTools class with methods to run commands and create HTTPS certificates
- Exported necessary plugins including crypto and fs for node
- Updated test cases to include tests for HTTPS certificate creation

## 2024-09-17 - 5.0.25 - fix(core)
Fix typos in package.json, update dependencies and update workflow.

- Fixed references to deprecated package names in workflows and package.json.
- Updated versions of @push.rocks dependencies to latest stable.
- Corrected scripts in package.json to reflect new build and documentation commands.
- Fixed async startup in browser tests.

## 2024-08-17 - 5.0.24 - fix(dependencies)
Update dependencies

- Updated @push.rocks/smartexpect from ^1.0.21 to ^1.1.0
- Updated @push.rocks/smartjson from ^5.0.16 to ^5.0.20
- Updated @push.rocks/smartpromise from ^4.0.2 to ^4.0.4
- Updated @push.rocks/smarttime from ^4.0.6 to ^4.0.8
- Updated @types/node from ^20.11.30 to ^22.4.0

## 2024-05-29 - 5.0.23 - General Update
update description

## 2024-04-14 to 2024-04-15 - 5.0.22 - Configuration Updates and Bug Fixes
Multiple updates in tsconfig and npmextra.json

- fix(core): update
- update tsconfig
- update npmextra.json: githost

## 2024-03-19 - 5.0.21 to 5.0.17 - Bug Fix Release
Multiple core fixes and updates without specific feature changes

- fix(core): update

## 2024-03-13 - 5.0.16 - Bug Fix Release
- fix(core): update

## 2023-08-12 - 5.0.15 to 5.0.13 - Bug Fix Release
Multiple core fixes and updates without specific feature changes

- fix(core): update

## 2023-07-13 - 5.0.12 to 5.0.10 - Bug Fix Release
Multiple core fixes and updates without specific feature changes

- fix(core): update

## 2023-06-22 - 5.0.9 to 5.0.7 - Bug Fix Release
Multiple core fixes and updates without specific feature changes

- fix(core): update

## 2022-07-24 - 5.0.6 to 5.0.3 - Bug Fix Release
Multiple core fixes and updates without specific feature changes

- fix(core): update

## 2022-03-14 - 5.0.2 to 5.0.0 - Initial Release of Version 5.x.x
Multiple bug fixes and updates.
- fix(core): update

## 2022-03-14 - 4.0.9 to 4.0.8 - Bug Fix Release
- fix(core): update

## 2022-02-28 - 4.0.7 to 4.0.4 - Bug Fix Release
Multiple core fixes and updates without specific feature changes

- fix(core): update

## 2022-02-02 - 4.0.3 to 4.0.1 - Bug Fix Release
- fix(core): update

## 2022-01-21 - 4.0.0 - Major Release
Version 4.x.x Major improvements and core fixes

## 2021-12-10 - 3.2.15 - Breaking Change
BREAKING CHANGE(core): switch to @pushrocks/smartexpect

## 2021-12-10 - 3.2.14 - Bug Fix Release
- fix(core): update

## 2021-02-13 - 3.2.13 - Bug Fix Release
- fix(core): update

## 2021-01-26 - 3.2.12 to 3.2.11 - Bug Fix Release
- fix(core): update

## 2020-07-11 - 3.2.10 to 3.2.8 - Bug Fix Release
- fix(core): update

## 2020-07-08 - 3.2.7 to 3.2.4 - Bug Fix Release
Multiple core fixes and updates without specific feature changes

- fix(core): update

## 2020-07-08 - 3.2.5 - Documentation Update
- update readme

## 2019-11-16 - 3.1.0 - New Feature
- feat(pretask): introduce new pretask functionality for setting up testing environment

## 2019-11-16 - 3.0.14 - New Feature
- feat(tools): can now ensure certain directories

## 2019-08-23 - 3.0.13 - Bug Fix Release
- fix(core): update

## 2019-08-22 - 3.0.12 - Bug Fix Release
- fix(core): update

## 2019-06-19 - 3.0.11 - Bug Fix Release
- fix(core): update

## 2019-04-10 - 3.0.9 to 3.0.8 - Bug Fix Release
- fix(core): update

## 2018-09-03 - 3.0.7 - Bug Fix Release
- fix(core): update

## 2018-09-02 - 3.0.6 - Dependency Update
- fix(dependencies): update to latest versions

## 2018-08-08 - 3.0.5 - New Feature
- fix(core): add tap.only option

## 2018-08-08 - 3.0.4 - Dependency Update
- fix(dependencies): update

## 2018-08-08 - 3.0.3 - Dependency Update
- fix(dependencies): use @git.zone/tsbuild instead of npmts

## 2018-07-18 - 3.0.2 - Dependency Update
- fix(dependencies): now typings-global free

## 2018-07-13 - 3.0.1 - Dependency Update
- fix(dependencies): update

## 2018-07-13 - 3.0.0 - Package Update
- fix(package): npm access level

## 2018-06-28 - 2.0.2 - Breaking Change
BREAKING CHANGE(package): change scope

## 2018-06-28 - 2.0.1 - Security Update
- fix(security): add snyk file

## 2018-02-27 - 2.0.0 - Compatibility Update
- fix(core): fix node 10.x.x compatibility

## 2017-10-11 - 1.1.8 - Update
- update to use latest smartchai

## 2017-10-11 - 1.1.7 - Update
- update ci

## 2017-10-10 - 1.1.6 - Documentation Update
- add new docs

## 2017-10-09 - 1.1.5 - Feature Update
- now has working leak detection

## 2017-03-26 - 1.0.9 - Standards Update
- update to latest standards
